/******************************************************************************/
#include"matriisi.h"
#include"varit.h"

#define XSTEP            30
#define ISO_LUKU        100

class cMuunnettuIkkuna{
  protected:
    HWND hwnd;
    HPEN hpen,old;
    RECT Rct;
    cMatrix Origo;
    int xstep, xjako, yjako;
    double fc,dx,dy;
    cMatrix Muunnos, Apu;  //Apu koordinaatiston piirtoon.
    int jako;
    int kuva;
    int aktiivinen;
    HDC hdc;
  public:
    cMuunnettuIkkuna(int a=0,HWND hWnd=0,int k=0,cMatrix M=1.0, int xStep=XSTEP, double factor=1.0,HDC hDC=0)
    {
         aktiivinen=a;
   	 hwnd=hWnd; xstep=xStep; fc=factor;
   	 hdc=hDC;
         kuva=k; //piirretaan=p;
         aseta_jako();
   	 Muunnos=M; Apu=1;
     }
     int move(const cVec &y1);
     int line(const cVec &y1);
     int line(const cJana &j);
     int text(const cVec &y1,const char *s);
     double Jako(void);
     int Kuva(void);
     HDC Hdc(void);
     HWND Kahva(void);
     int aseta_hdc(HDC Hdc);
     int aseta_jako(void);
     int koordinaatisto(const cVec &place,int axel=0,HPEN kyna=RGB(0,0,0),const int verkko=0);
     int piirra_jako(const cVec &place,const int axel,const int verkko);
     int tarkistus(cVec &b);
     int muuta_step(const int muutos);
     cMatrix sijoita(cMatrix &A);
     cMatrix muunna(const cMatrix &H);
     cMatrix yksikkom(void);
     cMatrix yksikkokoord(void);
     cVec vektori_reaaliksi(cVec &a );
     int palauta(const cMatrix &A);
     int kaanna_o(cMatrix &apu);
     void luo_kyna(HPEN pen);
     void poista_kyna(void);
     int aseta_aktiivinen(int a);
     int Aktiivinen(void);
 };

