#include"muunnik.h"
/******************************************************************************/
 class cPiirrettava_objekti{
  protected:
    cVec kp;
    cMatrix Mat;
    int kuvattu;
  public:
    HPEN vari;
    cPiirrettava_objekti(cMatrix mat,HPEN kyna,cVec b,int onko) {kp=b; kuvattu=onko; vari=kyna;Mat=mat;}
    virtual cVec oikea_yla(void){return kp;}
    virtual int piirra(cMuunnettuIkkuna I)const{ return 0;}
    int vaihdavari(HPEN v);
    int piirretaanko(cMuunnettuIkkuna I);
    int PiirraPois(cMuunnettuIkkuna A);
    cVec anna_paikka(void);//26.6
};

/******************************************************************************/
class cSateellinen:public cPiirrettava_objekti{
  protected:
    double sade,kerroin;
    cVec lp;
  public:
    cSateellinen(cMatrix mat=1,HPEN kyna=color[0],double r=1.0,double kerr=1.0,cVec keskip=0.0,cVec loppup=0,int onko_kuvaa=0):
    cPiirrettava_objekti(mat,kyna,keskip,onko_kuvaa) {
      sade=r; kerroin=kerr; lp=loppup;
    }
    int aseta_kuvattu(int i){kuvattu=i; return 0;}
    virtual int piirra(cMuunnettuIkkuna A)const  {return 0;}
    virtual cVec oikea_yla(void){return lp;}
    //    virtual int PiirraPois(cMuunnettuIkkuna A){return 0;}
    virtual int jana(cVec &a, cVec &b){return 0;}
    virtual int aseta_alkupiste(const cVec &a) {return 0;}
    virtual int aseta_loppupiste(const cVec &l){return 0;}
    virtual int tee_littea_kuutio(cVec loppup){return 0;}
    virtual cMatrix matsij(const cMatrix &C){return Mat;}
};

