/*******************************************************************************
   Moduli:        tietorak.cpp
   Tarkoitus:     ......
   Projekti:      Winlin, Cum laude approbatur -harjoitusty
   Tekijt:       Virpi Kivinen & Tiina Mkinen
   Tehty:         1.1.96
   Muutettu       1.7.96
   Mit muutettu: + listtyyt
   Puutteet:      mkki

*******************************************************************************/

/****************************************************************************************
class cOtukset{
    cSateellinen *otukset[MAX_OTUKSIA];
    int orkkeja;
  public:
  ....
};
    Tietorakenne, johon piirrettvt talletetaan:

    cOtukset &operator=(cOtukset &otus)  -Sijoituksen uudelleen mrittely
    int kopioi_taulukko(cOtukset &otus)  -Osoitintaulukon kopiointi
    cSateellinen *eka_otus(void)         -Palauttaa osoittimen ensimmisen olioon (cSateellinen)
    cSateellinen *seuraava_otus(void)    -Palauttaa seuraavan olion osoittimen, kunnes NULL
    int lisaa(cSateellinen *otus)        -Lis osoitintaulukkoon parametrina tuodun
                                          new:ll luodun cSateellinen *:n.
    int tuhoa();                         -Tuhoaa silmukassa luodut oliot.

/****************************************************************************************/

#include<windows.h>
#include<windowsx.h>
#include"tietorak.h"


//cOtukset:n metodit:

cSateellinen *cOtukset::eka_otus(void)
{
  return otukset[0];
}

cSateellinen *cOtukset::seuraava_otus(void)
{
  static int apu=orkkeja;
  if(apu<1) {apu=orkkeja;}// return NULL;}
  cSateellinen *o = otukset[orkkeja-apu+1];
  apu--;
  return o;
}

cSateellinen *cOtukset::viimeinen(void)
{
  return otukset[orkkeja-1];
}

int cOtukset::lisaa(cSateellinen *O)
{
  if (orkkeja>=MAX_OTUKSIA-1) return 1;
  otukset[orkkeja]=O;
  orkkeja ++;
  otukset[orkkeja]=NULL;
  return 0;
}

int cOtukset::kopioi_taulukko(cOtukset &otus)
{
  int i;
  cSateellinen *p;

  tuhoa();

  orkkeja=otus.orkkeja;
  for (i=0; i<MAX_OTUKSIA; i++){
    p=new cSateellinen();
    *p=*otus.otukset[i];
    otukset[i]=p;
  }
  return 0;
}

int cOtukset::tuhoa(void)
{
  int i;
  for (i=0;i<orkkeja;i++) {
    delete otukset[i];
    otukset[i]=NULL;
  }
  orkkeja=0;
  return 0;
}

//26.6.
int cOtukset::tuhoa_viimeinen(void)
{
  orkkeja--;
  delete otukset[orkkeja];
  otukset[orkkeja]=NULL;
  return 0;
}

cOtukset &cOtukset::operator=(cOtukset &otus)
{
  if ( &otus==this )return *this;
  kopioi_taulukko(otus);
  return *this;
}
